
#ifndef MP1243_h
#define MP1243_h

#include "Arduino.h"

//===========================================================
#define   MP1243_ADDRESS   0x41   
//===========================================================
#define   MP1243_VOLL      0x00
#define   MP1243_VOLR      0x01
#define   MP1243_BASS      0x02
#define   MP1243_TREBLE    0x03
#define   MP1243_SWITCH    0x08
//===========================================================
#define   MP1243_IS_BIT    1<<0
#define   MP1243_ML0_BIT   1<<1
#define   MP1243_ML1_BIT   1<<2
#define   MP1243_STL_BIT   1<<3
#define   MP1243_EFL_BIT   1<<4
#define   MP1243_MU_BIT    0x20

#define   VOLUME_MASK      0x3F
#define   BASS_MASK        0x0F
#define   SOURCE_MASK      0x07
#define   SIGNAL_MASK      0x18

#define   MP1243_CHAN_1_STEREO   (MP1243_ML1_BIT | MP1243_ML0_BIT)
#define   MP1243_CHAN_2_STEREO   (MP1243_ML1_BIT | MP1243_ML0_BIT | MP1243_IS_BIT)
#define   MP1243_CHAN_1_A        (MP1243_ML0_BIT)
#define   MP1243_CHAN_1_B        (MP1243_ML1_BIT)
#define   MP1243_CHAN_2_A        (MP1243_ML0_BIT | MP1243_IS_BIT)
#define   MP1243_CHAN_2_B        (MP1243_ML1_BIT | MP1243_IS_BIT)
#define   MP1243_MONO            0x00
#define   MP1243_LINEAR_STEREO   (MP1243_STL_BIT)
#define   MP1243_PSEUDO_STEREO   (MP1243_EFL_BIT)
#define   MP1243_SPATIAL_STEREO  (MP1243_EFL_BIT | MP1243_STL_BIT)


class MP1243
{
  public:
    MP1243 ();
    static void Init ();
    static void SetParam (byte Param, byte Value);
    static void SelectInput (byte Input);
    static void SelectSignal (byte Signal);
    static void Mute_ON ();
    static void Mute_OFF ();
    static byte GetParam (byte Param);
    static byte GetInput ();
    static byte GetSignal ();
    static boolean GetMuteState ();
            
  private:
    static void Write (byte Param, byte Value);
    
};

extern MP1243 MP1243_EQUALIZER;

#endif
 

